<template>
  <v-card>
    <v-toolbar color='primary' dense>
      <v-toolbar-title>
        Сделки
      </v-toolbar-title>
      <v-spacer />
      <v-btn color='secondary' :to='{ name: "OffersCreate" }'>
        <v-icon>mdi-plus</v-icon> Создать сделку
      </v-btn>
    </v-toolbar>
    <v-data-table
      v-if='serverPagination'
      :headers='headers'
      :items='items'
      show-expand
      single-expand
      :server-items-length='serverPagination.total'
      :options.sync='options'
    >
      <template v-slot:top>
        <container fluid>
          <v-row dense>
            <v-col cols='12' sm='6'>
              <v-select
                v-model='options.status'
                dense
                outlined
                label='Статус'
                hide-details
                :items='statuses'
                clearable
              />
            </v-col>
            <v-col cols='12' sm='6'>
              <v-select
                v-model='options.type'
                dense
                outlined
                label='Тип'
                hide-details
                :items='types'
                clearable
              />
            </v-col>
          </v-row>
        </container>
      </template>
      <template v-slot:item._id='{ index }'>
        {{ index + 1 }}
      </template>
      <template v-slot:item.amount='{ item }'>
        {{ item.amount | fromScaledAmount }}
      </template>
      <template v-slot:item.rate='{ item }'>
        {{ (item.rate.price / 100).toLocaleString() }} {{ item.rate.currency }}
      </template>
      <template v-slot:item.status='{ item }'>
        <offer-status :status='item.status' />
      </template>
      <template v-slot:item.type='{ item }'>
        <offer-type :type='item.type' />
      </template>
      <template v-slot:item.createdAt='{ item  }'>
        {{ item.createdAt | localDateString }}
      </template>
      <template v-slot:expanded-item='{ item, headers }'>
        <td :colspan="headers.length">
          <container>
            <v-row>
              <v-col cols='12' md='6'>
                <offer-info-card :offer='item' />
              </v-col>
              <v-col cols='12' md='6'>
                <bank-details-card v-if='item.bankDetails' :bank-details='item.bankDetails'></bank-details-card>
              </v-col>
            </v-row>
          </container>
        </td>
      </template>
    </v-data-table>
  </v-card>
</template>

<script lang='ts'>

import Vue from 'vue';
import Component from 'vue-class-component';
import { DataOptions, DataTableHeader } from 'vuetify';
import { OfferApiListRequest, OfferResponse, PaginationResponse } from '@/api/ledius-token';
import OfferStatus from '@/components/offers/OfferStatus.vue';
import OfferType from '@/components/offers/OfferType.vue';
import BankDetailsCard from '@/components/bank-details/BankDetailsCard.vue';
import OfferInfoCard from './OfferInfoCard.vue';
import { Watch } from 'vue-property-decorator';
import { OfferStatusEnum, OfferTypeEnum } from '@/api/patch/ledius-token.enums';

type OfferFilter = {
  type?: OfferTypeEnum|null,
  status?: OfferStatusEnum|null,
};

@Component({
  components: {
    OfferStatus,
    OfferType,
    BankDetailsCard,
    OfferInfoCard
  }
})
export default class OffersTable extends Vue {
  private readonly headers: DataTableHeader[] =[
    {
      text: 'ID',
      value: '_id'
    },
    {
      text: 'LDS',
      value: 'amount'
    },
    {
      text: 'RUB',
      value: 'rate',
      sortable: false
    },
    {
      text: 'Статус',
      value: 'status'
    },
    {
      text: 'Тип',
      value: 'type'
    },
    {
      text: 'Дата создания',
      value: 'createdAt'
    },
    {
      text: '',
      value: '_actions',
      sortable: false
    },
    {
      text: '',
      value: 'data-table-expand'
    }
  ];

  private readonly options: DataOptions & OfferFilter = {
    sortBy: [],
    itemsPerPage: 10,
    groupBy: [],
    groupDesc: [],
    multiSort: false,
    mustSort: false,
    page: 1,
    sortDesc: [],
    type: undefined,
    status: undefined
  };

  private get types(): { text: string, value: number}[] {
    return [
      { text: 'Продажа', value: OfferTypeEnum.SELL },
      { text: 'Покупка', value: OfferTypeEnum.BUY }
    ];
  }

  private get statuses(): { text: string, value: number}[] {
    return [
      { text: 'Открыт', value: OfferStatusEnum.OPENED },
      { text: 'Зарезервирован', value: OfferStatusEnum.RESERVED },
      { text: 'Исполнен', value: OfferStatusEnum.FULFILLED },
      { text: 'Закрыт', value: OfferStatusEnum.CLOSED }
    ];
  }

  private get items(): OfferResponse[] {
    return this.$store.getters['exchange/offers/offers'];
  }

  private get serverPagination(): PaginationResponse | null {
    return this.$store.getters['exchange/offers/pagination'];
  }

  @Watch('options', {
    deep: true
  })
  private async onOptionsChanged(options: DataOptions & OfferFilter): Promise<void> {
    console.log(options);
    await this.$store.dispatch('exchange/offers/fetchOffers', {
      paginationPage: options.page - 1,
      paginationPageSize: options.itemsPerPage === -1 ? this.serverPagination?.total : options.itemsPerPage,
      paginationOrder: options.sortDesc[0] ? 'DESC' : 'ASC',
      paginationOrderBy: options.sortBy[0],
      type: options.type ?? undefined,
      status: options.status ?? undefined
    } as OfferApiListRequest);
  }

  private async mounted(): Promise<void> {
    await this.$store.dispatch('exchange/offers/fetchOffers', { } as OfferApiListRequest);
  }
}

</script>

<style scoped>

</style>
